var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useDeep } from './client.js';
import React, { useMemo } from 'react';
import * as dz from 'react-dropzone';
export const Files = React.memo(function Files(_a) {
    var { Component = 'div', render = ({ getRootProps, input, isDragAccept, isDragActive, isDragReject, children, deep, Props, Component, }) => (React.createElement(Component, Object.assign({}, getRootProps({}), { bg: isDragActive ? 'deepBgDark' : isDragAccept ? 'deepBgActive' : isDragReject ? 'deepBgDanger' : 'transparent', cursor: isDragActive ? 'drag' : undefined }, Props),
        input,
        children)), children, prevent = false, onDrop, insert = {}, containerId, onInsert, Props = {} } = _a, props = __rest(_a, ["Component", "render", "children", "prevent", "onDrop", "insert", "containerId", "onInsert", "Props"]);
    const deep = useDeep();
    const { getInputProps, getRootProps, isDragActive, isDragAccept, isDragReject, } = useFiles(Object.assign({ prevent,
        onDrop,
        insert,
        containerId,
        onInsert }, props));
    const input = React.createElement("input", Object.assign({}, getInputProps()));
    return render({
        getRootProps,
        input,
        isDragActive,
        isDragAccept,
        isDragReject,
        children,
        deep,
        Props,
        Component,
    });
});
export function useFiles(_a) {
    var { prevent = false, onDrop: _onDrop, insert = {}, type_id: _type_id, containerId, onInsert } = _a, props = __rest(_a, ["prevent", "onDrop", "insert", "type_id", "containerId", "onInsert"]);
    const deep = useDeep();
    const type_id = useMemo(() => _type_id || deep.idLocal('@deep-foundation/core', 'AsyncFile'), [_type_id]);
    const onDrop = (files, a, event) => __awaiter(this, void 0, void 0, function* () {
        var _b, _c;
        let _prevent = prevent;
        _onDrop && _onDrop(files, a, event, () => { _prevent = true; });
        if (!_prevent) {
            for (const file of files) {
                const result = yield deep.insert(Object.assign({ file,
                    type_id,
                    containerId }, insert));
                onInsert && onInsert((_c = (_b = result === null || result === void 0 ? void 0 : result.data) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.id, file, a, event);
            }
        }
    });
    const dropzone = dz.useDropzone(Object.assign({ onDrop }, props));
    return dropzone;
}
export function base64ToFile(dataurl, filename) {
    return __awaiter(this, void 0, void 0, function* () {
        var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1], bstr = atob(arr[arr.length - 1]), n = bstr.length, u8arr = new Uint8Array(n);
        while (n--) {
            u8arr[n] = bstr.charCodeAt(n);
        }
        return new File([u8arr], filename, { type: mime });
    });
}
export function fileToBase64(file) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((res, rej) => {
            var reader = new FileReader();
            reader.readAsDataURL(file);
            reader.onload = function () {
                res(String(reader.result));
            };
            reader.onerror = function (error) {
                rej(error);
            };
        });
    });
}
//# sourceMappingURL=files.js.map