import { HasuraApi } from '@deep-foundation/hasura/api.js';
import { ContainerController } from '../container-controller.js';
import { Id } from '../minilinks.js';
export declare const DOCKER: string;
export declare const api: HasuraApi;
export declare function makePromiseResult(promiseId: Id, resolvedTypeId: Id, promiseResultTypeId: Id, result: any, promiseReasonTypeId: Id, handleInsertId: any): any;
export declare function processPromises(promises: any[], handleOperationsIds: any[], promiseId: Id, promiseResultTypeId: Id, promiseReasonTypeId: Id, resolvedTypeId: Id, rejectedTypeId: Id, log: any): Promise<void>;
export declare const containerController: ContainerController;
export declare function getJwt(handlerId: Id, useRunnerDebug: any): Promise<{
    token: string;
    linkId: any;
}>;
export declare const useRunner: ({ code, isolationProviderImageName, handlerId, data, }: {
    code: string;
    handlerId: Id;
    isolationProviderImageName: string;
    data: any;
}) => Promise<{
    error?: string;
}>;
export declare const handlerOperations: {
    Insert: string;
    Update: string;
    Delete: string;
};
export declare function handleOperation(operation: keyof typeof handlerOperations, triggeredByLinkId: Id, oldLink: any, newLink: any, valuesOperation?: string): Promise<void>;
export declare function handleSelectorOperation(operation: keyof typeof handlerOperations, triggeredByLinkId: Id, oldLink: any, newLink: any, valuesOperation?: string): Promise<void>;
export declare function handleSchedule(handleScheduleLink: any, operation: 'INSERT' | 'DELETE'): Promise<void>;
export declare function handleGql(handleGqlLink: any, operation: 'INSERT' | 'DELETE'): Promise<void>;
export declare function handlePort(handlePortLink: any, operation: 'INSERT' | 'DELETE'): Promise<void>;
declare const _default: (req: any, res: any) => Promise<any>;
export default _default;
export declare const handleGqlLinks: () => Promise<void>;
