var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { createPrepareFunction, createDeepClientFunction, createSyncInsertTriggerFunction, createSyncDeleteTriggerFunction, createSyncUpdateTriggerFunction, createSyncDeleteStringsTriggerFunction, createSyncInsertStringsTriggerFunction, createSyncUpdateStringsTriggerFunction, createSyncDeleteNumbersTriggerFunction, createSyncInsertNumbersTriggerFunction, createSyncUpdateNumbersTriggerFunction, createSyncDeleteObjectsTriggerFunction, createSyncInsertObjectsTriggerFunction, createSyncUpdateObjectsTriggerFunction } from "../migrations/1655979260869-sync-handlers.js";
import Debug from 'debug';
import { api } from '../migrations/1616701513782-links.js';
const debug = Debug('deeplinks:migrations:plv8');
const log = debug.extend('log');
export const up = () => __awaiter(void 0, void 0, void 0, function* () {
    log('up');
    yield api.sql(createPrepareFunction);
    yield api.sql(createDeepClientFunction);
    yield api.sql(createSyncInsertTriggerFunction);
    yield api.sql(createSyncUpdateTriggerFunction);
    yield api.sql(createSyncDeleteTriggerFunction);
    yield api.sql(createSyncInsertStringsTriggerFunction);
    yield api.sql(createSyncUpdateStringsTriggerFunction);
    yield api.sql(createSyncDeleteStringsTriggerFunction);
    yield api.sql(createSyncInsertNumbersTriggerFunction);
    yield api.sql(createSyncUpdateNumbersTriggerFunction);
    yield api.sql(createSyncDeleteNumbersTriggerFunction);
    yield api.sql(createSyncInsertObjectsTriggerFunction);
    yield api.sql(createSyncUpdateObjectsTriggerFunction);
    yield api.sql(createSyncDeleteObjectsTriggerFunction);
});
export const down = () => __awaiter(void 0, void 0, void 0, function* () {
    log('down');
});
//# sourceMappingURL=1693460330175-sync-handlers-update.js.map